#include<bits/stdc++.h>
using namespace std;
long long T,n;
long long s1_0=0,s1_1=0,s2_0=0,s2_1=0;
char s1[100007],s2[100007],t1[100007],t2[100007];
long long s1n0[100007],s2n0[100007];
long long s1n1[100007],s2n1[100007];
long long ans=0;



int main()
{
	ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
	freopen("edit.in","r",stdin);
	freopen("edit.out","w",stdout);
	
	cin>>T;
	
	bool same=0;
	bool tt=0;
	for(int p=0;p<T;p++)
	{
		cin>>n;
		ans=0;
		s1_0=0;
		s1_1=0;
		s2_0=0;
		s2_1=0;
		for(long long i=1;i<=n;i++)
		{
			cin>>s1[i];
		}
		for(long long i=1;i<=n;i++)
		{
			cin>>s2[i];
			if(s2[i]==s1[i])
			{
				ans++;
			}
		}
		for(long long i=1;i<=n;i++)
		{
			cin>>t1[i];
		}
		for(long long i=1;i<=n;i++)
		{
			cin>>t2[i];
		}
		cout<<ans<<endl;
	}
	return 0;
}










